unit Unit1;
{
Numerical Methods:
Components to solve mathematical problems
numericaly, namely:
- Integral: Trapezium, MiddlePoint, Simpson, Romberg, Gauss Legendre
- Polynom Interpolation: Lagrange, Newton, Newton-Gregory
- Linear equation: Gauss, Gauss-Jordan, Inverse Matrix, LU Decomposition, Jacobi, Gauss-Seidel
- Non-Linear equation: Bolzano, Regula Falsi, Fixed Point, Newton-Rhapson, Secant
- First, Second, Third, Fourth Derivative: Forward/Backward/Central Difference Approximation
}


interface

uses
  SysUtils,Controls, Forms,ComCtrls, StdCtrls, Classes,
  UNonLinearEquation, ULinearEquation, UDerivative,
  UInterpolation, UIntegral;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LTrapesium: TLabel;
    LTTengah: TLabel;
    LSimpson1: TLabel;
    Lsimpson3: TLabel;
    LGL2: TLabel;
    LGL3: TLabel;
    LGL4: TLabel;
    LGL5: TLabel;
    LGL6: TLabel;
    Label10: TLabel;
    LRomberg: TLabel;
    Button1: TButton;
    TabSheet2: TTabSheet;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    LLagrange: TLabel;
    LNewton: TLabel;
    LForwardNG: TLabel;
    LBackwardNG: TLabel;
    Button2: TButton;
    TabSheet3: TTabSheet;
    Label15: TLabel;
    Label16: TLabel;
    LPivot1: TLabel;
    LPivot2: TLabel;
    Button3: TButton;
    LNaif1: TLabel;
    LNaif2: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    LLagrange2: TLabel;
    LNewton2: TLabel;
    LForward2: TLabel;
    LBackward2: TLabel;
    Label23: TLabel;
    LPivot3: TLabel;
    LNaif3: TLabel;
    Label24: TLabel;
    LPivot4: TLabel;
    Lnaif4: TLabel;
    Label25: TLabel;
    LNaifGJ1: TLabel;
    LNaifGJ2: TLabel;
    LNaifGJ3: TLabel;
    LNaifGJ4: TLabel;
    Label26: TLabel;
    LPivotGJ1: TLabel;
    LPivotGJ2: TLabel;
    LPivotGJ3: TLabel;
    LPivotGJ4: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    LGS1: TLabel;
    LGS2: TLabel;
    LGS3: TLabel;
    LGS4: TLabel;
    Label30: TLabel;
    LJacobi1: TLabel;
    LJacobi2: TLabel;
    LJacobi3: TLabel;
    LJacobi4: TLabel;
    TabSheet4: TTabSheet;
    Label31: TLabel;
    Label32: TLabel;
    LBolzano: TLabel;
    LRegulaFalsi: TLabel;
    Label37: TLabel;
    Button4: TButton;
    Label45: TLabel;
    LFixedPoint: TLabel;
    Label50: TLabel;
    LNR: TLabel;
    Label55: TLabel;
    LSecant: TLabel;
    TabSheet5: TTabSheet;
    Label33: TLabel;
    LFirstForward2Points: TLabel;
    LSecondForward5Points: TLabel;
    Label38: TLabel;
    LThirdForward5Points: TLabel;
    Button5: TButton;
    Label35: TLabel;
    LFirstForward3Points: TLabel;
    LFourthForward5Points: TLabel;
    LFirstForward4Points: TLabel;
    LThirdForward4Points: TLabel;
    Label42: TLabel;
    LFirstForward5Points: TLabel;
    LSecondForward3Points: TLabel;
    Label43: TLabel;
    Label41: TLabel;
    LSecondForward4Points: TLabel;
    Label40: TLabel;
    Label44: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label46: TLabel;
    Label49: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label65: TLabel;
    Integral: TIntegral;
    Interpolation: TInterpolation;
    Derivative: TDerivative;
    Linear: TLinear;
    NonLinear: TNonLinear;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label34: TLabel;
    LFirstBackward2Points: TLabel;
    LSecondBackward5Points: TLabel;
    LThirdBackward5Points: TLabel;
    Label73: TLabel;
    LFirstBackward3Points: TLabel;
    LFourthBackward5Points: TLabel;
    LFirstBackward4Points: TLabel;
    LThirdBackward4Points: TLabel;
    LFirstBackward5Points: TLabel;
    LSecondBackward3Points: TLabel;
    LSecondBackward4Points: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label36: TLabel;
    LSecondCentral7Points: TLabel;
    LThirdCentral7Points: TLabel;
    LFirstCentral3Points: TLabel;
    LFourthCentral7Points: TLabel;
    LFirstCentral5Points: TLabel;
    LThirdCentral5Points: TLabel;
    LFirstCentral7Points: TLabel;
    LSecondCentral3Points: TLabel;
    LSecondCentral5Points: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    LFourthCentral5Points: TLabel;
    cbProblem2: TRadioButton;
    cbProblem1: TRadioButton;
    Label39: TLabel;
    Label64: TLabel;
    LInv1: TLabel;
    LInv2: TLabel;
    LInv3: TLabel;
    LInv4: TLabel;
    LLU1: TLabel;
    LLU2: TLabel;
    LLU3: TLabel;
    LLU4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses math;

function FSin(x:array of double):double;
begin
     result:=sin(x[0]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     with Integral do
     begin
          LTrapesium.Caption:=format('%.5f',[Trapezium(pi/4,pi/2,50,FSin)]);
          LTTengah.Caption:=format('%.5f',[MiddlePoint(pi/4,pi/2,50,FSin)]);
          LSimpson1.Caption:=format('%.5f',[Simpson1_3(pi/4,pi/2,50,FSin)]);
          Lsimpson3.Caption:=format('%.5f',[Simpson3_8(pi/4,pi/2,51,FSin)]);
          LRomberg.Caption:=format('%.5f',[Romberg(pi/4,pi/2,64,FSin)]);
          LGL2.Caption:=format('%.5f',[GL2Points(pi/4,pi/2,FSin)]);
          LGL3.Caption:=format('%.5f',[GL3Points(pi/4,pi/2,FSin)]);
          LGL4.Caption:=format('%.5f',[GL4Points(pi/4,pi/2,FSin)]);
          LGL5.Caption:=format('%.5f',[GL5Points(pi/4,pi/2,FSin)]);
          LGL6.Caption:=format('%.5f',[GL6Points(pi/4,pi/2,FSin)]);
     end;
end;

function FCos(x:array of double):double;
begin
     result:=cos(x[0]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     with Interpolation do
     begin
          //case 1
          LLagrange.Caption:=format('%.5f',[Lagrange(2.5,[0,1,2,3,4],[1,0.5403,-0.4161,-0.99,-0.6536],5)]);
          LNewton.Caption:=format('%.5f',[Newton(2.5,[0,1,2,3,4],[1,0.5403,-0.4161,-0.99,-0.6536],5)]);
          LForwardNG.Caption:=format('%.5f',[ForwardNewtonGregory(2.5,[0,1,2,3,4],[1,0.5403,-0.4161,-0.99,-0.6536],5)]);
          LBackwardNG.Caption:=format('%.5f',[BackwardNewtonGregory(2.5,[0,1,2,3,4],[1,0.5403,-0.4161,-0.99,-0.6536],5)]);

          //case 2
          LLagrange2.Caption:=format('%.5f',[Approximation(2.5,FCos,0,4,1,Lagrange)]);
          LNewton2.Caption:=format('%.5f',[Approximation(2.5,FCos,0,4,1,Newton)]);
          LForward2.Caption:=format('%.5f',[Approximation(2.5,FCos,0,4,1,ForwardNewtonGregory)]);
          LBackward2.Caption:=format('%.5f',[Approximation(2.5,FCos,0,4,1,BackwardNewtonGregory)]);
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var x:array[0..3] of double;
    input:TMatrik;

    procedure Init;
    var i:integer;
    begin
         for i:=0 to 3 do x[i]:=0;
    end;

begin
     with Linear do
     begin
          input[0,0]:=4;
          input[0,1]:=-1;
          input[0,2]:=2;
          input[0,3]:=3;
          input[1,0]:=0;
          input[1,1]:=-2;
          input[1,2]:=7;
          input[1,3]:=-4;
          input[2,0]:=0;
          input[2,1]:=0;
          input[2,2]:=6;
          input[2,3]:=5;
          input[3,0]:=0;
          input[3,1]:=0;
          input[3,2]:=0;
          input[3,3]:=3;

          Init;
          InverseMatrix(input,[20,-7,4,6],x);
          LInv1.Caption:=format('%.5f',[x[0]]);
          LInv2.Caption:=format('%.5f',[x[1]]);
          LInv3.Caption:=format('%.5f',[x[2]]);
          LInv4.Caption:=format('%.5f',[x[3]]);

         Init;
          PivotingGauss(input,[20,-7,4,6],x);
          LPivot1.Caption:=format('%.5f',[x[0]]);
          LPivot2.Caption:=format('%.5f',[x[1]]);
          LPivot3.Caption:=format('%.5f',[x[2]]);
          LPivot4.Caption:=format('%.5f',[x[3]]);

          Init;
          PivotingGaussJordan(input,[20,-7,4,6],x);
          LPivotGJ1.Caption:=format('%.5f',[x[0]]);
          LPivotGJ2.Caption:=format('%.5f',[x[1]]);
          LPivotGJ3.Caption:=format('%.5f',[x[2]]);
          LPivotGJ4.Caption:=format('%.5f',[x[3]]);

          Init;
          LU(input,[20,-7,4,6],x);
          LLU1.Caption:=format('%.5f',[x[0]]);
          LLU2.Caption:=format('%.5f',[x[1]]);
          LLU3.Caption:=format('%.5f',[x[2]]);
          LLU4.Caption:=format('%.5f',[x[3]]);

          x[0]:=1;
          x[1]:=2;
          x[2]:=2;
          GaussSeidel(input,[20,-7,4,6],x);
          LGS1.Caption:=format('%.5f',[x[0]]);
          LGS2.Caption:=format('%.5f',[x[1]]);
          LGS3.Caption:=format('%.5f',[x[2]]);
          LGS4.Caption:=format('%.5f',[x[3]]);

          x[0]:=1;
          x[1]:=2;
          x[2]:=2;
          Jacobi(input,[20,-7,4,6],x);
          LJacobi1.Caption:=format('%.5f',[x[0]]);
          LJacobi2.Caption:=format('%.5f',[x[1]]);
          LJacobi3.Caption:=format('%.5f',[x[2]]);
          LJacobi4.Caption:=format('%.5f',[x[3]]);

          Init;
          NaiveGauss(input,[20,-7,4,6],x);
          LNaif1.Caption:=format('%.5f',[x[0]]);
          LNaif2.Caption:=format('%.5f',[x[1]]);
          LNaif3.Caption:=format('%.5f',[x[2]]);
          LNaif4.Caption:=format('%.5f',[x[3]]);

          Init;
          NaiveGaussJordan(input,[20,-7,4,6],x);
          LNaifGJ1.Caption:=format('%.5f',[x[0]]);
          LNaifGJ2.Caption:=format('%.5f',[x[1]]);
          LNaifGJ3.Caption:=format('%.5f',[x[2]]);
          LNaifGJ4.Caption:=format('%.5f',[x[3]]);
     end;
end;

function FCoba(x:array of double):double;
begin
     result:=exp(x[0])-5*sqr(x[0]);
end;

function FCobaAksen(x:array of double):double;
begin
     result:=exp(x[0])-10*x[0];
end;

function FLelaran(x:array of double):double;
begin
     result:=sqrt(exp(x[0])/5);
end;

procedure TForm1.Button4Click(Sender: TObject);
var akar:double;
begin
     with NonLinear do
     begin
          LBolzano.Caption:=format('%.5f',[Bolzano(-1,1,FCoba)]);
          akar:=1;
          FixedPoint(akar,FLelaran);
          LFixedPoint.Caption:=format('%.5f',[akar]);
          akar:=-1;
          NewtonRaphson(akar,FCoba,FCobaAksen);
          LNR.Caption:=format('%.5f',[akar]);
          LSecant.Caption:=format('%.5f',[Secant(0.5,1,FCoba)]);
          LRegulaFalsi.Caption:=format('%.5f',[RegulaFalsi(0,1,FCoba)]);
     end;
end;

function FTes(x:array of double):double;
begin
     result:=IntPower(x[0],4)+IntPower(x[0],3)+sqr(x[0]);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     with Derivative do
     begin
       if cbProblem1.Checked then
       begin
          //case 1 of first derivative
          LFirstForward2Points.Caption:=format('%.5f',[FirstForward2Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstForward3Points.Caption:=format('%.5f',[FirstForward3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstForward4Points.Caption:=format('%.5f',[FirstForward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstForward5Points.Caption:=format('%.5f',[FirstForward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LFirstBackward2Points.Caption:=format('%.5f',[FirstBackward2Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstBackward3Points.Caption:=format('%.5f',[FirstBackward3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstBackward4Points.Caption:=format('%.5f',[FirstBackward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstBackward5Points.Caption:=format('%.5f',[FirstBackward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LFirstCentral3Points.Caption:=format('%.5f',[FirstCentral3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstCentral5Points.Caption:=format('%.5f',[FirstCentral5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFirstCentral7Points.Caption:=format('%.5f',[FirstCentral7Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          //case 1 of second derivative
          LSecondForward3Points.Caption:=format('%.5f',[SecondForward3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondForward4Points.Caption:=format('%.5f',[SecondForward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondForward5Points.Caption:=format('%.5f',[SecondForward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LSecondBackward3Points.Caption:=format('%.5f',[SecondBackward3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondBackward4Points.Caption:=format('%.5f',[SecondBackward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondBackward5Points.Caption:=format('%.5f',[SecondBackward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LSecondCentral3Points.Caption:=format('%.5f',[SecondCentral3Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondCentral5Points.Caption:=format('%.5f',[SecondCentral5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LSecondCentral7Points.Caption:=format('%.5f',[SecondCentral7Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          //case 1 of third derivative
          LThirdForward4Points.Caption:=format('%.5f',[ThirdForward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LThirdForward5Points.Caption:=format('%.5f',[ThirdForward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LThirdBackward4Points.Caption:=format('%.5f',[ThirdBackward4Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LThirdBackward5Points.Caption:=format('%.5f',[ThirdBackward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LThirdCentral5Points.Caption:=format('%.5f',[ThirdCentral5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LThirdCentral7Points.Caption:=format('%.5f',[ThirdCentral7Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          //case 1 of fourth derivative
          LFourthForward5Points.Caption:=format('%.5f',[FourthForward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LFourthBackward5Points.Caption:=format('%.5f',[FourthBackward5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);

          LFourthCentral5Points.Caption:=format('%.5f',[FourthCentral5Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
          LFourthCentral7Points.Caption:=format('%.5f',[FourthCentral7Points1(2.5,[1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75],[FTes([1.5]),FTes([1.75]),FTes([2]),FTes([2.25]),FTes([2.5]),FTes([2.75]),FTes([3]),FTes([3.25]),FTes([3.5]),FTes([3.75])])]);
       end
       else
       begin
          //case 2 of first derivative
          LFirstForward2Points.Caption:=format('%.5f',[FirstForward2Points2(2.5,FTes,0.125)]);
          LFirstForward3Points.Caption:=format('%.5f',[FirstForward3Points2(2.5,FTes,0.125)]);
          LFirstForward4Points.Caption:=format('%.5f',[FirstForward4Points2(2.5,FTes,0.125)]);
          LFirstForward5Points.Caption:=format('%.5f',[FirstForward5Points2(2.5,FTes,0.125)]);

          LFirstBackward2Points.Caption:=format('%.5f',[FirstBackward2Points2(2.5,FTes,0.125)]);
          LFirstBackward3Points.Caption:=format('%.5f',[FirstBackward3Points2(2.5,FTes,0.125)]);
          LFirstBackward4Points.Caption:=format('%.5f',[FirstBackward4Points2(2.5,FTes,0.125)]);
          LFirstBackward5Points.Caption:=format('%.5f',[FirstBackward5Points2(2.5,FTes,0.125)]);

          LFirstCentral3Points.Caption:=format('%.5f',[FirstCentral3Points2(2.5,FTes,0.125)]);
          LFirstCentral5Points.Caption:=format('%.5f',[FirstCentral5Points2(2.5,FTes,0.125)]);
          LFirstCentral7Points.Caption:=format('%.5f',[FirstCentral7Points2(2.5,FTes,0.125)]);

          //case 2 of second derivative
          LSecondForward3Points.Caption:=format('%.5f',[SecondForward3Points2(2.5,FTes,0.125)]);
          LSecondForward4Points.Caption:=format('%.5f',[SecondForward4Points2(2.5,FTes,0.125)]);
          LSecondForward5Points.Caption:=format('%.5f',[SecondForward5Points2(2.5,FTes,0.125)]);

          LSecondBackward3Points.Caption:=format('%.5f',[SecondBackward3Points2(2.5,FTes,0.125)]);
          LSecondBackward4Points.Caption:=format('%.5f',[SecondBackward4Points2(2.5,FTes,0.125)]);
          LSecondBackward5Points.Caption:=format('%.5f',[SecondBackward5Points2(2.5,FTes,0.125)]);

          LSecondCentral3Points.Caption:=format('%.5f',[SecondCentral3Points2(2.5,FTes,0.125)]);
          LSecondCentral5Points.Caption:=format('%.5f',[SecondCentral5Points2(2.5,FTes,0.125)]);
          LSecondCentral7Points.Caption:=format('%.5f',[SecondCentral7Points2(2.5,FTes,0.125)]);

          //case 2 of third derivative
          LThirdForward4Points.Caption:=format('%.5f',[ThirdForward4Points2(2.5,FTes,0.125)]);
          LThirdForward5Points.Caption:=format('%.5f',[ThirdForward5Points2(2.5,FTes,0.125)]);

          LThirdBackward4Points.Caption:=format('%.5f',[ThirdBackward4Points2(2.5,FTes,0.125)]);
          LThirdBackward5Points.Caption:=format('%.5f',[ThirdBackward5Points2(2.5,FTes,0.125)]);

          LThirdCentral5Points.Caption:=format('%.5f',[ThirdCentral5Points2(2.5,FTes,0.125)]);
          LThirdCentral7Points.Caption:=format('%.5f',[ThirdCentral7Points2(2.5,FTes,0.125)]);

          //case 2 of fourth derivative
          LFourthForward5Points.Caption:=format('%.5f',[FourthForward5Points2(2.5,FTes,0.125)]);

          LFourthBackward5Points.Caption:=format('%.5f',[FourthBackward5Points2(2.5,FTes,0.125)]);

          LFourthCentral5Points.Caption:=format('%.5f',[FourthCentral5Points2(2.5,FTes,0.125)]);
          LFourthCentral7Points.Caption:=format('%.5f',[FourthCentral7Points2(2.5,FTes,0.125)]);
       end;
     end;
end;

end.
